
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*Robot Parameters
Length 54cm
Width 45cm
10cm tyre diameter
Distancepercount= PI * diameterWheel/CountsperRevolution.
//Countsperrotationofrobo=(trackwidth/diameterWheel)*Countsperrevolution
provides a resolution of 64 counts per revolution of the motor shaft, which corresponds to 3200 counts per revolution of the gearbox’s output shaft.*/
#define distancePerCount 0.72//cm
#define radiansPerCount 0.0109
////////////////////////////////////////// Data to be sent ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
//////////////////////////// Ultrasonic Sensor Variables and Macros ////////////////////////////////////////////////////////////////////////
#include <NewPing.h>

#define SONAR_NUM     3 // Number or sensors.
#define MAX_DISTANCE 200 // Maximum distance (in cm) to ping.
#define PING_INTERVAL 33 // Milliseconds between sensor pings (29ms is about the min to avoid cross-sensor echo).
#define Avoid_at 100
unsigned long pingTimer[SONAR_NUM]; // Holds the times when the next ping should happen for each sensor.
unsigned int cm[SONAR_NUM];         // Where the ping distances are stored.
uint8_t currentSensor = 0;          // Keeps track of which sensor is active.
int rgt=0;
int lft=0;
boolean Obs= LOW;
NewPing sonar[SONAR_NUM] = {     // Sensor object array.
  //NewPing(50, 43, MAX_DISTANCE), // Each sensor's trigger pin, echo pin, and max distance to ping.
  NewPing(48, 42, MAX_DISTANCE),
  NewPing(36, 38, MAX_DISTANCE),
  NewPing(35, 40, MAX_DISTANCE),
 };
 

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define diameterWheel 10 /// cm
#define BODY_LENGTH 54
#define trackwidth  45
#include <Wire.h>
#include <digitalWriteFast.h>
#include <ServoShield.h>
#include <Servo.h>
Servo ultrasonic;
long currentMillis=0;
long previousMillis=0;
long interval=200;
boolean Auto=false;
long Heading=0;
long Magnitude=0;
long Direction=0;
//////////////////////////////////// Variables & MACROS for Robotic Arm ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* Arm dimensions( mm ) */
#define BASE_HGT 215     //base hight 2.65"
#define HUMERUS 280      //shoulder-to-elbow "bone" 5.75"
#define ULNA 260.325        //elbow-to-wrist "bone" 7.375"
#define GRIPPER 10.00          //gripper (incl.heavy duty wrist rotate mechanism) length 3.94"
#define ftl(x) ((x)>=0?(long)((x)+0.5):(long)((x)-0.5))  //float to long conversion
float prev_x=0,prev_y=0,prev_z=0,prev_twist=0,prev_grip;
/* Servo names/numbers */
/* Base servo HS-485HB */
#define BAS_SERVO 0
/* Shoulder Servo HS-5745-MG */
#define SHL_SERVO 3
/* Elbow Servo HS-5745-MG */
#define ELB_SERVO 1
/* Wrist servo HS-645MG */
#define WRI_SERVO 7
/* Wrist rotate servo HS-485HB */
#define WRO_SERVO 5
/* Gripper servo HS-422 */
#define GRI_SERVO 16
/* pre-calculations */
float hum_sq = HUMERUS*HUMERUS;
float uln_sq = ULNA*ULNA;
/*buffers*/
float bas_servopulse_prev = 1300; 
float shl_servopulse_prev = 2200;
float elb_servopulse_prev = 2400;
float wri_servopulse_prev = 1400; 
float writwist_servopulse_prev=1400;
float gripper_servopulse_prev=1400;
 
ServoShield servos;                       //ServoShield object
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
char command[80];
boolean obstacle=false;
boolean object=false;
/// Magnetometer Variables//////
#define magneto_ADDRESS 0x1E
int mag_x, mag_y, mag_z;
float heading;
float heading_send;
float right_side;
float left_side;
////////////Encoder Variables//////////////////
double val_1=0;
double val_2=0;
int ASet_1;
int ASet_2;
int BSet_1;
int BSet_2;
double RobotAngle;
double distancechange;
///////////////////////////////////////////////////
void setup()
{
  servos_init();
  Serial.begin(115200);
  Serial.print("WarMachine Initializing...");
  Serial.print("Commands : w,a,s,d for movement , 'Remote' to acquire control , 'Autopilot'for auto");
  Encoders_Init();
  Wire.begin();
  pinMode(2,INPUT);
  pinMode(3,INPUT);
  pinMode(19,INPUT);
  pinMode(18,INPUT);
  pinModeFast(51,OUTPUT);
  pinModeFast(49,OUTPUT);
  pinModeFast(47,OUTPUT);
  pinModeFast(45,OUTPUT);
  ultrasonic.attach(50);
  for(int i=0;i < 180;i++)
  {
  ultrasonic.write(i);
  delay(10);
  }
  for(int i=180 ; i >0 ; i--)
  {
  ultrasonic.write(i);
  delay(10);
  }
  ultrasonic.write(90);
}
void loop()
{
  if(Auto)
  {
    Heading=sonar[0].ping_cm();
    right_side=sonar[1].ping_cm();
    left_side=sonar[2].ping_cm();
    if(Serial.available() > 0)
    {
      int f=Serial.read();
      if(f== 'n')
      {
        Serial.print(Magnitude);
        Serial.print(" ");
        Serial.print(Direction);
        Serial.print(" ");
        update_magneto();
        Serial.print(" ");
        Serial.println(Obs);
        Magnitude=0;
        Direction=0;
        Obs=LOW;
      }
    }
   if(Heading < Avoid_at && Heading !=0)
    {
    Obs=HIGH;  
    backward();
    delay(40);  
    kill_motors();
    ultrasonic.write(50);
    delay(400);
    rgt=sonar[0].ping_cm();
    delay(100);
    ultrasonic.write(140);
    delay(400);
    lft=sonar[0].ping_cm();
    delay(100);
   if(rgt > lft && right_side > 20)
    {
      val_1=0;
      val_2=0;
      right();
      delay(150);
      axis_update();
    }
    if(rgt < lft && left_side > 20)
    {
      val_1=0;
      val_2=0;
      left();
      delay(150);
      axis_update();
    }
    else
    {
     val_1=0;
     val_2=0;
     backward();
     delay(250);
     axis_update();
    }
    }
   else
  {
    ultrasonic.write(90);
    delay(200);
    val_1=0;
    val_2=0;
    forward();
    delay(250);
    kill_motors();
    axis_update();
    Obs=LOW;
    
  }
  }


  if(Serial.available() > 0)
  {
  ProcessComms();
  }
} 
void forward()
{
       digitalWriteFast2(47,HIGH);
      digitalWriteFast2(45,LOW);
      digitalWriteFast2(51,LOW);
      digitalWriteFast2(49,HIGH);
      ///////////////////////
     
  
}
void backward()
{
      digitalWriteFast2(47,LOW);
      digitalWriteFast2(45,HIGH);
      digitalWriteFast2(51,HIGH);
      digitalWriteFast2(49,LOW);
  
      
}
void left()
{
      digitalWriteFast2(47,LOW);
      digitalWriteFast2(45,HIGH);
      digitalWriteFast2(51,LOW);
      digitalWriteFast2(49,HIGH);
           
}
void right()
{
     digitalWriteFast2(47,HIGH);
      digitalWriteFast2(45,LOW);
      digitalWriteFast2(51,HIGH);
      digitalWriteFast2(49,LOW);
   
     
}
void kill_motors()
{
      digitalWriteFast2(47,LOW);
      digitalWriteFast2(45,LOW);
      digitalWriteFast2(51,LOW);
      digitalWriteFast2(49,LOW);  
}

/// Magnetometer Data Acquisition

float update_magneto()
{
  Wire.beginTransmission(magneto_ADDRESS); 
  Wire.write(byte(0x02));
  Wire.write(byte(0x01));
  Wire.endTransmission();
  Wire.beginTransmission(magneto_ADDRESS);
  Wire.write(byte(0x03));       // Send request to X MSB register
  Wire.endTransmission();

  Wire.requestFrom(magneto_ADDRESS, 6);    // Request 6 bytes; 2 bytes per axis
  if(Wire.available() <=6) {    // If 6 bytes available
    mag_x = Wire.read() << 8 | Wire.read();
    mag_z = Wire.read() << 8 | Wire.read();
    mag_y = Wire.read() << 8 | Wire.read();
  }
  
  // Print raw values
  heading=atan2(mag_x, mag_y);
  float declinationAngle = 0.0457;
  heading += declinationAngle;
  
  // Correct for when signs are reversed.
  if(heading < 0)
    heading += 2*PI;
    
  // Check for wrap due to addition of declination.
  if(heading > 2*PI)
    heading -= 2*PI;
   
  // Convert radians to degrees for readability.
  float headingDegrees = heading * 180/M_PI; 
  Serial.print(headingDegrees);
}

void Encoders_Init()
{
  ASet_1 = digitalReadFast2(2);
  BSet_1 = digitalReadFast2(3);   // read the input pin
  ASet_2 = digitalReadFast2(18);
  BSet_2 = digitalReadFast2(19);   // read the input pin
  
 attachInterrupt(0, INCRE1, CHANGE);
 attachInterrupt(1, DECRE1, CHANGE);
 attachInterrupt(4, INCRE2,CHANGE);
 attachInterrupt(5, DECRE2,CHANGE);
}
void INCRE1()
{
  ASet_1 = digitalReadFast2(2) == HIGH;
  val_1 += (ASet_1 != BSet_1) ? +1 : -1;
}

void DECRE1()
{
  BSet_1 = digitalReadFast2(3) == HIGH;
  val_1 += (ASet_1 == BSet_1) ? +1 : -1;
}
void INCRE2()
{
  ASet_2 = digitalReadFast2(18) == HIGH;
  val_2 += (ASet_2 != BSet_2) ? +1 : -1;
}

void DECRE2()
{
  BSet_2 = digitalReadFast2(19) == HIGH;
  val_2 += (ASet_2 == BSet_2) ? +1 : -1;
}


void ProcessComms()
{
 char c= Serial.read();
 sprintf(command, "%s%c", command, c);
    if(c=='a')
    {
     kill_motors();
    val_1=0;
    val_2=0;   
   left();
   delay(interval);
   kill_motors();
  sprintf(command, "");
  axis_update();
    }
    if(c=='d')
  {
    kill_motors();
    val_1=0;
    val_2=0;
    right();
    delay(interval);
    kill_motors();
  sprintf(command, "");
  axis_update();
  }
  if(c=='w')
  {
    kill_motors();
    val_1=0;
    val_2=0;   
    forward();
    delay(interval);
    kill_motors();
  sprintf(command, "");
  axis_update();
  }
  if(c=='s')
  {
    kill_motors();
    val_1=0;
    val_2=0;
     backward();
     delay(interval);
     kill_motors();
sprintf(command, "");
axis_update();
  }
  if (c == 'r')
    {
      ProcessCommand(command);
      sprintf(command, "");
    }
     if (c == 'z')
    {
      Auto=false;
      kill_motors();
    }
    if(c== 'n')
      {
        Serial.print(Magnitude);
        Serial.print("    ");
        Serial.println(Direction);
        Magnitude=0;
        Direction=0;
      }
  }
void ProcessCommand(char process[80])
{
  char cmd[5];
  int param1, param2, param3,param4,param5;
  sscanf(process, "%s", cmd);
  
  if (strstr(cmd, "SS") != 0)
  {
  sscanf(process, "%s", cmd, &param4);
  interval=param4;
  }
  
  if (strstr(cmd, "SA") != 0)
  {
    sscanf(process, "%s %d %d %d %d %d", cmd, &param1, &param2, &param3,&param4,&param5);
    Serial.print("XAxis");
    Serial.print(param1);
    Serial.print(" ");
    Serial.print("YAXIS");
    Serial.print(param2);
    Serial.print(" ");
    Serial.print("ZAXIS");
    Serial.print(param3);
    Serial.print(" ");
    Serial.print("Gripper Twist");
    Serial.print(param4);
    Serial.print(" ");
    Serial.print("Gripper");
    Serial.print(param5);
    Serial.print("  ");
    Serial.println(" OK");
  if(prev_x !=param1 || prev_y!=param2 || prev_z!=param3)
  {
  set_arm(param1,param2,param3,param4,param5);
  }
  prev_x=param1;
  prev_y=param2;
  prev_z=param3;

  }
 
  if (strstr(cmd, "Autopilot") != 0)
  {
   Auto=true;
  }
  
}
//////////////////////////////////////////////////// ARM FUNCTIONS ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void servo_park()
{
  servos.setposition( BAS_SERVO, 1300 );
  servos.setposition( SHL_SERVO, 2200 );
  servos.setposition( ELB_SERVO, 2400 );
  servos.setposition( WRI_SERVO, 1400 );
  servos.setposition( WRO_SERVO, 1400 );
  servos.setposition( GRI_SERVO, 900 );
  return;
}
void servos_init()
{
  servos.setbounds( BAS_SERVO, 600, 2400 );
  servos.setbounds( SHL_SERVO, 600, 2400 );
  servos.setbounds( ELB_SERVO, 800, 2400 );
  servos.setbounds( WRI_SERVO, 600, 2400 );
  servos.setbounds( WRO_SERVO, 600, 2400 );
  servos.setbounds( GRI_SERVO, 600, 2400 );
  /**/
  servos.start();                         //Start the servo shield
  servo_park();
}

/* move servos to parking position */


void zero_x()
{
  for( double yaxis = 150.0; yaxis < 356.0; yaxis += 1 ) {
    set_arm( 0, yaxis, 127.0, 1400 ,1400);
    delay( 10 );
  }
  for( double yaxis = 356.0; yaxis > 150.0; yaxis -= 1 ) {
    set_arm( 0, yaxis, 127.0,1400 ,1400 );
    delay( 10 );
  }
}
 
/* moves arm in a straight line */
void line()
{
    for( double xaxis = -100.0; xaxis < 100.0; xaxis += 0.5 ) {
      set_arm( xaxis, 250, 100,1400,1400 );
      delay( 10 );
    }
    for( float xaxis = 100.0; xaxis > -100.0; xaxis -= 0.5 ) {
      set_arm( xaxis, 250, 100,1400,1400);
      delay( 10 );
    }
}
 
void circle()
{
  #define RADIUS 80.0
  //float angle = 0;
  float zaxis,yaxis;
  for( float angle = 0.0; angle < 360.0; angle += 1.0 ) {
      yaxis = RADIUS * sin( radians( angle )) + 200;
      zaxis = RADIUS * cos( radians( angle )) + 200;
      set_arm( 0, yaxis, zaxis,1400,1400);
      delay( 1 );
  }
}

void servos_set(float from,float to , int servo_num)
{
  long x=ftl(from);
  long y=ftl(to);
  if(from > to)
  {
    for(long i = from ; i >= to ; i--)
    {
      servos.setposition(servo_num,i);
      delay(3);
    }
  }
  if(from < to)
  {
    for(long i = from ; i <= to ; i++)
    {
      servos.setposition(servo_num,i);
      delay(3);
    }
  }
  
}

void set_arm( float x, float y, float z, float grip_angle_d,float grip_twist)
{
  float grip_angle_r = radians( grip_angle_d );    //grip angle in radians for use in calculations
  /* Base angle and radial distance from x,y coordinates */
  float bas_angle_r = atan2( x, y );
  float rdist = sqrt(( x * x ) + ( y * y ));
  /* rdist is y coordinate for the arm */
  y = rdist;
  /* Grip offsets calculated based on grip angle */
  float grip_off_z = ( sin( grip_angle_r )) * GRIPPER;
  float grip_off_y = ( cos( grip_angle_r )) * GRIPPER;
  /* Wrist position */
  float wrist_z = ( z - grip_off_z ) - BASE_HGT;
  float wrist_y = y - grip_off_y;
  /* Shoulder to wrist distance ( AKA sw ) */
  float s_w = ( wrist_z * wrist_z ) + ( wrist_y * wrist_y );
  float s_w_sqrt = sqrt( s_w );
  /* s_w angle to ground */
  //float a1 = atan2( wrist_y, wrist_z );
  float a1 = atan2( wrist_z, wrist_y );
  /* s_w angle to humerus */
  float a2 = acos((( hum_sq - uln_sq ) + s_w ) / ( 2 * HUMERUS * s_w_sqrt ));
  /* shoulder angle */
  float shl_angle_r = a1 + a2;
  float shl_angle_d = degrees( shl_angle_r );
  /* elbow angle */
  float elb_angle_r = acos(( hum_sq + uln_sq - s_w ) / ( 2 * HUMERUS * ULNA ));
  float elb_angle_d = degrees( elb_angle_r );
  float elb_angle_dn = -( 180.0 - elb_angle_d );
  /* wrist angle */
  float wri_angle_d = ( grip_angle_d - elb_angle_dn ) - shl_angle_d;
 
  /* Servo pulses */
  float bas_servopulse = 1400.0 - (( degrees( bas_angle_r )) * 11.11 );
  double shl_servopulse = 1400.0 + (( shl_angle_d - 90.0 ) * 6.6 );
  float elb_servopulse = 1400.0 -  (( elb_angle_d - 90.0 ) * 6.6 );
  float wri_servopulse = 1400.0 + ( wri_angle_d  * 11.1 );
 /*Previous pulses */
 
 /* Set servos */
  /*servos.setposition( BAS_SERVO, bas_servopulse );
  servos.setposition( SHL_SERVO, shl_servopulse );
  servos.setposition( ELB_SERVO, elb_servopulse );
  servos.setposition( WRI_SERVO, wri_servopulse );
   */
Serial.print(bas_servopulse);
Serial.print("   ");
Serial.print(shl_servopulse);
Serial.print("   ");
Serial.println(elb_servopulse);
servos_set(bas_servopulse_prev,bas_servopulse,BAS_SERVO);
servos_set(shl_servopulse_prev,shl_servopulse,ELB_SERVO);
servos_set(elb_servopulse_prev,elb_servopulse,WRI_SERVO);
servos.setposition( WRO_SERVO,grip_twist*10);
servos.setposition( GRI_SERVO, grip_angle_d*10);
bas_servopulse_prev=bas_servopulse;
elb_servopulse_prev=elb_servopulse;
shl_servopulse_prev=shl_servopulse;
wri_servopulse_prev=wri_servopulse;
}
void axis_update()
{
  if(Serial.available() > 0)
  {
    /// When robot moves in straight line
val_1=val_1/32;
val_2=val_2/32;
distancechange=((val_1 + val_2)/2.0)*distancePerCount;
// Trackwidth= Body width
///RadiansperCount= PI*(WheelDiameter/TrackWidth)/CountsperRevolution
RobotAngle=((val_2-val_1)*radiansPerCount)*57.29; // Angle change in degrees
Magnitude= Magnitude + distancechange;
Direction= Direction + RobotAngle;
/// Motor gives 3200 counts per revolution
  }

}
void arm_routine()
{
int front=0,left=0,right=0; 
front=sonar[0].ping_cm();
right=sonar[1].ping_cm();
left=sonar[2].ping_cm();

if((left > 100 || left == 0)&&(right > 100 ||  right == 0))
{

 for(int q=0 ; q<=300 ; q+=50)
{
  set_arm(0,0,q,140,140);
} 
for(int w=-300 ; w<=400 ; w+=50)
{
  set_arm(w,0,0,140,140);
}
for(int b=-400 ; b<=400; b+=50)
{
  set_arm(0,b,0,140,140);
}
servos_set(1400,1300,BAS_SERVO);
servos_set(960,2200,ELB_SERVO);
servos_set(955,2400,WRI_SERVO);
bas_servopulse_prev=1400;
elb_servopulse_prev=2400;
shl_servopulse_prev=2200;
}
if(front > 100 || front == 0)
{
  for(int q=0 ; q<=300 ; q+=50)
{
  set_arm(0,0,q,140,140);
servos_set(1400,1300,BAS_SERVO);
servos_set(900,2200,ELB_SERVO);
servos_set(1602,2400,WRI_SERVO);
bas_servopulse_prev=1400;
elb_servopulse_prev=2400;
shl_servopulse_prev=2200;
} 
}

}


